using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyPrimitive
{
	public short[]	va;
	public uint[]	ca;

	public MyPrimitive( String path )
	{
		va = TUAssets.readTSVArray<short>( path + "/vertex.tsv" );
		ca = TUAssets.readTSVArray<uint>( path + "/color.tsv" );
	}

	public void draw( float x, float y, float z, float a )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

	public void draw( float x, float y, float z, float a, float s, float v, float w )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.Scalef( s, 1, 1 );		//	傫ύX
		GL1.Translatef( v, w, 0 );	//	sړ
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

}

class MyModel
{
	public static String[]	Name = { "Akichi", "Building","Hatake","House","Azemichi","Jisya","Platform","Ekisya", "Rail","Train", "House3", "House2", "House1", "House5", "Cursor" };
	public static Dictionary<String, MyPrimitive>	Pri = new Dictionary<String, MyPrimitive>();

	public static void load()
	{
		foreach( String s in Name ){
			Pri[ s ] = new MyPrimitive( s );
		}
	}

	public static void drawRail( int x, int y, int a )
	{
		if( a % 4 == 0 ){	//	90xP
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1, 0, -11 );
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1, 0,  11 );
			return;
		}

		if( a % 2 == 0 ){	//	45xP
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1.42f, 0, -11 );
			Pri[ "Rail" ].draw( x, y, 0, a * 22.5f, 1.42f, 0,  11 );
			return;
		}

		Pri[ "Rail" ].draw( x, y, 0, a * 22.5f + 3.9f, 1.25f,  8, 12 );
		Pri[ "Rail" ].draw( x, y, 0, a * 22.5f + 4.0f, 1.1f , 11, 33 );
	}

	public static void drawRail( int[] xyta )
	{
		if( xyta == null ){
			return;
		}

		for( int i = 0; i < xyta.Length; i += 4 ){
			drawRail( xyta[ i + 0 ] * 100,
			          xyta[ i + 1 ] * 100,
			          xyta[ i + 3 ] );
		}
	}
}

class MyMap
{
	public static readonly sbyte AKICHI		= 0;
	public static readonly sbyte BUILDING	= 1;
	public static readonly sbyte HATAKE		= 2;
	public static readonly sbyte HOUSE		= 3;
	public static readonly sbyte AZEMICHI	= 4;
	public static readonly sbyte JISYA		= 5;
	public static readonly sbyte PLATFORM	= 6;
	public static readonly sbyte EKISYA		= 7;
	public static readonly sbyte RAIL		= 8;
	public static readonly sbyte TRAIN		= 9;
	public static readonly sbyte HOUSE3		= 10;
	public static readonly sbyte HOUSE2		= 11;
	public static readonly sbyte HOUSE1		= 12;
	public static readonly sbyte HOUSE5		= 13;

	public static int		Width, Height;
	public static sbyte[]	Data;
	public static sbyte[]	Angle;

	public static int[] createRail( int sx, int sy, int ex, int ey )
	{
		int		dx = ex - sx;
		int		dy = ey - sy;
		int		lx = Math.Abs( dx );
		int		ly = Math.Abs( dy );
		int		len;
		if( lx < ly ){
			len = ly;
		}else{
			len = lx;
		}

		sx *= 2;
		sy *= 2;
		dx *= 2;
		dy *= 2;

		int[]	r = new int[ ( len + 1 ) * 4 ];
		int		ax = dx / len;
		int		ay = dy / len;
		for( int i = 0; i <= len; i++ ){
			r[ i * 4 + 0 ] = sx / 2;
			r[ i * 4 + 1 ] = sy / 2;
			r[ i * 4 + 2 ] = RAIL;
			r[ i * 4 + 3 ] = TULib.getAngle16( ax, ay );

			sx += ax;
			sy += ay;
		}

		return( r );
	}

	public static void draw()
	{
		for( int i = 0; i < Data.Length; i++ ){
			int		x = i % Width * 100;
			int		y = i / Width * 100;
			if( Data[ i ] == RAIL ){
				MyModel.Pri[ "Jisya" ].draw( x, y, 0, 0 );
				MyModel.drawRail( x, y, Angle[ i ] );	//	[`
				continue;
			}
			if( Data[ i ] == PLATFORM ){
				MyModel.Pri[ "Platform" ].draw( x, y, 0, Angle[ i ] * 22.5f );
				MyModel.drawRail( x, y, Angle[ i ] );	//	[`
				continue;
			}
			MyModel.Pri[ MyModel.Name[ Data[ i ] ] ].draw( x, y, 0, Angle[ i ] * 22.5f );
		}
	}

	public static void init( int width, int height )
	{
		Width = width;
		Height = height;

		Data = new sbyte[ Width * Height ];
		Angle = new sbyte[ Width * Height ];

		for( int i = 0; i < 10; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = BUILDING;
		}

		for( int i = 0; i < 1000; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HATAKE;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE5;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE3;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE2;
		}

		for( int i = 0; i < 100; i++ ){
			MyMap.Data[ TUGame.rnd( Height ) * Width + TUGame.rnd( Width ) ] = HOUSE1;
		}

		for( int y = 0; y < Height; y++ ){
			MyMap.Data[ y * Width + 16 ] = AZEMICHI;
			MyMap.Angle[ y * Width + 16 ] = 4;
		}

		for( int x = 0; x < Width; x++ ){
			MyMap.Data[ 16 * Width + x ] = RAIL;
			MyMap.Angle[ 16 * Width + x ] = 0;
		}

		MyMap.Data[ 17 * Width + 9 ] = RAIL;
		MyMap.Angle[ 17 * Width + 9 ] = 9;
		MyMap.Data[ 17 * Width + 23 ] = RAIL;
		MyMap.Angle[ 17 * Width + 23 ] = 7;

		for( int x = 10; x < 23; x++ ){
			MyMap.Data[ 16 * Width + x ] = PLATFORM;
			MyMap.Data[ 17 * Width + x ] = PLATFORM;
			MyMap.Angle[ 17 * Width + x ] = 8;
		}

		MyMap.Data[ 15 * Width + 16 ] = EKISYA;
		MyMap.Angle[ 15 * Width + 16 ] = 0;
	}

	public static void set( int x, int y, sbyte t, sbyte a )
	{
		MyMap.Data[ y * Width + x ] = t;
		MyMap.Angle[ y * Width + x ] = a;
	}

	public static void set( int[] xyta )
	{
		for( int i = 0; i < xyta.Length; i += 4 ){
			set( xyta[ i ], xyta[ i + 1 ], (sbyte)xyta[ i + 2 ], (sbyte)xyta[ i + 3 ] );
		}
	}
}

class ETrain : TURetroGame
{
	static float		PX = 1600;		//	vC[̍W
	static float		CenterX = 1600, CenterY = 1600;	//	ʒW
	static int			Score;			//	_
	static float		Mag = 1.0f;		//	{
	static float		WorldX, WorldY;	//	[hW
	static bool			MoveCenter;		//	Wړw
	static bool			MoveMouse;		//	}EXړtO
	static int			StartX = -1, StartY;	//	n_
	static int			EndX, EndY;		//	I_
	static int[]		Plan;			//	v

	public override void wmCreated()
	{
		Title = "Edɏ낤";
		MyMap.init( 40, 40 );
		MyModel.load();
		setFrameRate( 60 );
	}

	public override void onMouseClickL( int x, int y )
	{
		if( MoveMouse ){
			MoveMouse = false;
			return;
		}

		if( StartX < 0 ){
			StartX = EndX = getCursorX();
			StartY = EndY = getCursorY();
			return;
		}

		int		ex = getCursorX();
		int		ey = getCursorY();
		MyMap.set( MyMap.createRail( StartX, StartY, ex, ey ) );
		StartX = ex;
		StartY = ey;
	}

	public override void onMouseClickR( int x, int y )
	{
		if( StartX >= 0 ){
			StartX = -1;
			Plan = null;
		}
	}

	public override void onMouseWheel( int d )
	{
		Mag += d / 4.0f;
		if( Mag < 0.5f )	Mag = 0.5f;
		if( Mag > 2.0f )	Mag = 2.0f;
		MoveCenter = true;		//	Wړw
	}

	public override void wmTimer()
	{
		Score++;
		PX += 2;
		Invalidate();	//	ĕ`˗
	}

	public override void wmDraw()
	{
		GL1.ClearColor( 0xff5544ee );	//	ʃNA̐Fw
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.Scale( 0.0453f * Mag );	//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );
		GL1.LookAt(					//	_ݒ
		  -1,  -1,  0.817f,			//	J̈ʒu
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( -CenterX, -CenterY, 0 );	//	sړ

//		float[]	xyz = GL1.UnProject( MouseX, getHeight() - MouseY - 1 );
//		float[]	xyz = UnProjectMouse();	//	}EXW gluUnProject Ăяo
		UnProjectMouse( 0 );	//	}EXʒu ZW 0 ̃[hW擾Bʂ̓oϐ MouseW Ɋi[B
		if( MouseL | MoveCenter ){		//	}EX{^A͒Wړw̏ꍇ
			MoveCenter = false;
			float	dx = WorldX - MouseW[ 0 ];
			float	dy = WorldY - MouseW[ 1 ];
			if( dx != 0.0f || dy != 0.0f ){
				MoveMouse = true;
				CenterX += dx;
				CenterY += dy;
				GL1.Translatef( -dx, -dy, 0 );	//	sړ
			}
		}else{
			WorldX = MouseW[ 0 ];	//	}EXʒu ZW 0 ̃[hWXێĂB
			WorldY = MouseW[ 1 ];	//	}EXʒu ZW 0 ̃[hWYێĂB
		}

		MyMap.draw();			//	`

		//	Ԃ`
		for( int i = 0; i < 12; i++ ){
			MyModel.Pri[ "Train" ].draw( PX - i * 100, 1600, 0, 0 );
		}

		//	J[\`
		MyModel.Pri[ "Cursor" ].draw( getCursorX() * 100, getCursorY() * 100, 0, 0 );

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );

		//	v`
		if( StartX >= 0 ){
			if( EndX != getCursorX() || EndY != getCursorY() ){
				EndX = getCursorX();
				EndY = getCursorY();
				Plan = MyMap.createRail( StartX, StartY, EndX, EndY );
			}
			MyModel.drawRail( Plan );
		}

		GL1.PopMatrix();			//	}gbNXX^bNo

		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ
		draw( "SCORE " + Score );
	}

	static int getCursorX()
	{
		return( ( (int)WorldX + 50 ) / 100 );
	}

	static int getCursorY()
	{
		return( ( (int)WorldY + 50 ) / 100 );
	}

	static void Main()
	{
		new ETrain();
	}
}
